diff --git a/LibvirtTypes.cs b/LibvirtTypes.cs
index de307dc..fa776e9 100644
--- a/LibvirtTypes.cs
+++ b/LibvirtTypes.cs
@@ -16,6 +16,22 @@ namespace LibvirtBindings
 
     #region delegates
     ///<summary>
+    /// Signature of a function to use when there is an error raised by the library.
+    ///</summary>
+    ///<param name="userData">user provided data for the error callback</param>
+    ///<param name="error">the error being raised.</param>
+    public delegate void virErrorFunc(IntPtr userData, virError error);
+    /// <summary>
+    /// A callback function to be registered, and called when a domain event occurs
+    /// </summary>
+    /// <param name="conn">virConnect connection </param>
+    /// <param name="dom">The domain on which the event occured</param>
+    /// <param name="evt">The specfic virDomainEventType which occured</param>
+    /// <param name="detail">event specific detail information</param>
+    /// <param name="opaque">opaque user data</param>
+    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
+    public delegate void virConnectDomainEventCallback(IntPtr conn, IntPtr dom, virDomainEventType evt, int detail, IntPtr opaque);
+    ///<summary>
     /// Callback for receiving file handle events. The callback will be invoked once for each event which is pending.
     ///</summary>
     ///<param name="watch">watch on which the event occurred</param>
@@ -96,6 +112,94 @@ namespace LibvirtBindings
     #endregion
 
     #region structs
+    /// <summary>
+    /// the virError object
+    /// </summary>
+    [StructLayout(LayoutKind.Sequential)]
+    public class virError
+    {
+        /// <summary>
+        /// The error code, a virErrorNumber.
+        /// </summary>
+        [MarshalAs(UnmanagedType.I4)]
+        public virErrorNumber code;
+        /// <summary>
+        /// What part of the library raised this error.
+        /// </summary>
+        [MarshalAs(UnmanagedType.I4)]
+        public int domain;
+        /// <summary>
+        /// Human-readable informative error message.
+        /// </summary>
+        [MarshalAs(UnmanagedType.SysInt)]
+        private IntPtr message;
+        /// <summary>
+        /// Human-readable informative error message.
+        /// </summary>
+        public string Message
+        {
+            get { return Marshal.PtrToStringAnsi(message); }
+        }
+
+        /// <summary>
+        /// How consequent is the error.
+        /// </summary>
+        [MarshalAs(UnmanagedType.I4)]
+        public virErrorLevel level;
+        /// <summary>
+        /// Connection if available, deprecated see note above.
+        /// </summary>
+        [MarshalAs(UnmanagedType.SysInt)]
+        public IntPtr conn;
+        /// <summary>
+        /// Domain if available, deprecated see note above.
+        /// </summary>
+        [MarshalAs(UnmanagedType.SysInt)]
+        public IntPtr dom;
+        /// <summary>
+        /// Extra string information.
+        /// </summary>
+        [MarshalAs(UnmanagedType.SysInt)]
+        private IntPtr str1;
+        /// <summary>
+        /// Extra string information.
+        /// </summary>
+        public string Str1 { get { return Marshal.PtrToStringAnsi(str1); } }
+        /// <summary>
+        /// Extra string information.
+        /// </summary>
+        [MarshalAs(UnmanagedType.SysInt)]
+        private IntPtr str2;
+        /// <summary>
+        /// Extra string information.
+        /// </summary>
+        public string Str2 { get { return Marshal.PtrToStringAnsi(str2); } }
+        /// <summary>
+        /// Extra string information.
+        /// </summary>
+        [MarshalAs(UnmanagedType.SysInt)]
+        private IntPtr str3;
+        /// <summary>
+        /// Extra string information.
+        /// </summary>
+        public string Str3 { get { return Marshal.PtrToStringAnsi(str3); } }
+        /// <summary>
+        /// Extra number information.
+        /// </summary>
+        [MarshalAs(UnmanagedType.I4)]
+        public int int1;
+        /// <summary>
+        /// Extra number information.
+        /// </summary>
+        [MarshalAs(UnmanagedType.I4)]
+        public int int2;
+        /// <summary>
+        /// Network if available, deprecated see note above.
+        /// </summary>     
+        [MarshalAs(UnmanagedType.SysInt)]
+        public IntPtr net;
+    }
+
     ///<summary>
     /// Blocks domain statistics
     ///</summary>
@@ -310,7 +414,7 @@ namespace LibvirtBindings
             }
             set
             {
-                result = libVirt.StrDup(Marshal.StringToHGlobalAnsi(value));
+                result = NativeFunctions.StrDup(Marshal.StringToHGlobalAnsi(value));
             }
         }
     }
@@ -454,6 +558,446 @@ namespace LibvirtBindings
 
     #region enums
     ///<summary>
+    /// Enumerate errors
+    ///</summary>
+    public enum virErrorNumber
+    {
+        /// <summary>
+        /// No error
+        /// </summary>
+        VIR_ERR_OK = 0,
+        /// <summary>
+        /// Internal error
+        /// </summary>
+        VIR_ERR_INTERNAL_ERROR = 1,
+        /// <summary>
+        /// Memory allocation failure
+        /// </summary>
+        VIR_ERR_NO_MEMORY = 2,
+        /// <summary>
+        /// No support for this function
+        /// </summary>
+        VIR_ERR_NO_SUPPORT = 3,
+        /// <summary>
+        /// Could not resolve hostname
+        /// </summary>
+        VIR_ERR_UNKNOWN_HOST = 4,
+        /// <summary>
+        /// Can't connect to hypervisor
+        /// </summary>
+        VIR_ERR_NO_CONNECT = 5,
+        /// <summary>
+        /// Invalid connection object
+        /// </summary>
+        VIR_ERR_INVALID_CONN = 6,
+        /// <summary>
+        /// Invalid domain object
+        /// </summary>
+        VIR_ERR_INVALID_DOMAIN = 7,
+        /// <summary>
+        /// Invalid function argument
+        /// </summary>
+        VIR_ERR_INVALID_ARG = 8,
+        /// <summary>
+        ///  A command to hypervisor failed
+        /// </summary>
+        VIR_ERR_OPERATION_FAILED = 9,
+        /// <summary>
+        /// A HTTP GET command to failed
+        /// </summary>
+        VIR_ERR_GET_FAILED = 10,
+        /// <summary>
+        /// A HTTP POST command to failed
+        /// </summary>
+        VIR_ERR_POST_FAILED = 11,
+        /// <summary>
+        /// Unexpected HTTP error code
+        /// </summary>
+        VIR_ERR_HTTP_ERROR = 12,
+        /// <summary>
+        /// Failure to serialize an S-Expr
+        /// </summary>
+        VIR_ERR_SEXPR_SERIAL = 13,
+        /// <summary>
+        /// Could not open Xen hypervisor control
+        /// </summary>
+        VIR_ERR_NO_XEN = 14,
+        /// <summary>
+        /// Failure doing an hypervisor call
+        /// </summary>
+        VIR_ERR_XEN_CALL = 15,
+        /// <summary>
+        /// Unknown OS type
+        /// </summary>
+        VIR_ERR_OS_TYPE = 16,
+        /// <summary>
+        /// Missing kernel information
+        /// </summary>
+        VIR_ERR_NO_KERNEL = 17,
+        /// <summary>
+        /// Missing root device information
+        /// </summary>
+        VIR_ERR_NO_ROOT = 18,
+        /// <summary>
+        /// Missing source device information
+        /// </summary>
+        VIR_ERR_NO_SOURCE = 19,
+        /// <summary>
+        /// Missing target device information
+        /// </summary>
+        VIR_ERR_NO_TARGET = 20,
+        /// <summary>
+        /// Missing domain name information
+        /// </summary>
+        VIR_ERR_NO_NAME = 21,
+        /// <summary>
+        /// Missing domain OS information
+        /// </summary>
+        VIR_ERR_NO_OS = 22,
+        /// <summary>
+        /// Missing domain devices information
+        /// </summary>
+        VIR_ERR_NO_DEVICE = 23,
+        /// <summary>
+        /// Could not open Xen Store control
+        /// </summary>
+        VIR_ERR_NO_XENSTORE = 24,
+        /// <summary>
+        /// Too many drivers registered
+        /// </summary>
+        VIR_ERR_DRIVER_FULL = 25,
+        /// <summary>
+        /// Not supported by the drivers (DEPRECATED)
+        /// </summary>
+        VIR_ERR_CALL_FAILED = 26,
+        /// <summary>
+        /// An XML description is not well formed or broken
+        /// </summary>
+        VIR_ERR_XML_ERROR = 27,
+        /// <summary>
+        /// The domain already exist
+        /// </summary>
+        VIR_ERR_DOM_EXIST = 28,
+        /// <summary>
+        /// Operation forbidden on read-only connections
+        /// </summary>
+        VIR_ERR_OPERATION_DENIED = 29,
+        /// <summary>
+        /// Failed to open a conf file
+        /// </summary>
+        VIR_ERR_OPEN_FAILED = 30,
+        /// <summary>
+        /// Failed to read a conf file
+        /// </summary>
+        VIR_ERR_READ_FAILED = 31,
+        /// <summary>
+        /// Failed to parse a conf file
+        /// </summary>
+        VIR_ERR_PARSE_FAILED = 32,
+        /// <summary>
+        /// Failed to parse the syntax of a conf file
+        /// </summary>
+        VIR_ERR_CONF_SYNTAX = 33,
+        /// <summary>
+        /// Failed to write a conf file
+        /// </summary>
+        VIR_ERR_WRITE_FAILED = 34,
+        /// <summary>
+        /// Detail of an XML error
+        /// </summary>
+        VIR_ERR_XML_DETAIL = 35,
+        /// <summary>
+        /// Invalid network object
+        /// </summary>
+        VIR_ERR_INVALID_NETWORK = 36,
+        /// <summary>
+        /// The network already exist
+        /// </summary>
+        VIR_ERR_NETWORK_EXIST = 37,
+        /// <summary>
+        /// General system call failure
+        /// </summary>
+        VIR_ERR_SYSTEM_ERROR = 38,
+        /// <summary>
+        /// Some sort of RPC error
+        /// </summary>
+        VIR_ERR_RPC = 39,
+        /// <summary>
+        /// Error from a GNUTLS call
+        /// </summary>
+        VIR_ERR_GNUTLS_ERROR = 40,
+        /// <summary>
+        /// Failed to start network
+        /// </summary>
+        VIR_WAR_NO_NETWORK = 41,
+        /// <summary>
+        /// Domain not found or unexpectedly disappeared
+        /// </summary>
+        VIR_ERR_NO_DOMAIN = 42,
+        /// <summary>
+        /// Network not found
+        /// </summary>
+        VIR_ERR_NO_NETWORK = 43,
+        /// <summary>
+        /// Invalid MAC address
+        /// </summary>
+        VIR_ERR_INVALID_MAC = 44,
+        /// <summary>
+        /// Authentication failed
+        /// </summary>
+        VIR_ERR_AUTH_FAILED = 45,
+        /// <summary>
+        /// Invalid storage pool object
+        /// </summary>
+        VIR_ERR_INVALID_STORAGE_POOL = 46,
+        /// <summary>
+        /// Invalid storage vol object
+        /// </summary>
+        VIR_ERR_INVALID_STORAGE_VOL = 47,
+        /// <summary>
+        /// Failed to start storage
+        /// </summary>
+        VIR_WAR_NO_STORAGE = 48,
+        /// <summary>
+        /// Storage pool not found
+        /// </summary>
+        VIR_ERR_NO_STORAGE_POOL = 49,
+        /// <summary>
+        /// Storage pool not found
+        /// </summary>
+        VIR_ERR_NO_STORAGE_VOL = 50,
+        /// <summary>
+        /// Failed to start node driver
+        /// </summary>
+        VIR_WAR_NO_NODE = 51,
+        /// <summary>
+        /// Invalid node device object
+        /// </summary>
+        VIR_ERR_INVALID_NODE_DEVICE = 52,
+        /// <summary>
+        /// Node device not found
+        /// </summary>
+        VIR_ERR_NO_NODE_DEVICE = 53,
+        /// <summary>
+        /// Security model not found
+        /// </summary>
+        VIR_ERR_NO_SECURITY_MODEL = 54,
+        /// <summary>
+        /// Operation is not applicable at this time
+        /// </summary>
+        VIR_ERR_OPERATION_INVALID = 55,
+        /// <summary>
+        /// Failed to start interface driver
+        /// </summary>
+        VIR_WAR_NO_INTERFACE = 56,
+        /// <summary>
+        /// Interface driver not running
+        /// </summary>
+        VIR_ERR_NO_INTERFACE = 57,
+        /// <summary>
+        /// Invalid interface object
+        /// </summary>
+        VIR_ERR_INVALID_INTERFACE = 58,
+        /// <summary>
+        /// More than one matching interface found
+        /// </summary>
+        VIR_ERR_MULTIPLE_INTERFACES = 59,
+        /// <summary>
+        /// Failed to start secret storage
+        /// </summary>
+        VIR_WAR_NO_SECRET = 60,
+        /// <summary>
+        /// Invalid secret
+        /// </summary>
+        VIR_ERR_INVALID_SECRET = 61,
+        /// <summary>
+        /// Secret not found
+        /// </summary>
+        VIR_ERR_NO_SECRET = 62,
+        /// <summary>
+        /// Unsupported configuration construct
+        /// </summary>
+        VIR_ERR_CONFIG_UNSUPPORTED = 63,
+        /// <summary>
+        /// Timeout occurred during operation
+        /// </summary>
+        VIR_ERR_OPERATION_TIMEOUT = 64,
+        /// <summary>
+        /// A migration worked, but making the VM persist on the dest host failed
+        /// </summary>
+        VIR_ERR_MIGRATE_PERSIST_FAILED = 65,
+    }
+
+    /// <summary>
+    /// Enumrate types of domain errors
+    /// </summary>
+    public enum virErrorDomain
+    {
+        /// <summary>
+        /// None
+        /// </summary>
+        VIR_FROM_NONE = 0,
+        /// <summary>
+        /// Error at Xen hypervisor layer
+        /// </summary>
+        VIR_FROM_XEN = 1,
+        /// <summary>
+        /// Error at connection with xend daemon
+        /// </summary>
+        VIR_FROM_XEND = 2,
+        /// <summary>
+        /// Error at connection with xen store
+        /// </summary>
+        VIR_FROM_XENSTORE = 3,
+        /// <summary>
+        /// Error in the S-Expression code
+        /// </summary>
+        VIR_FROM_SEXPR = 4,
+        /// <summary>
+        /// Error in the XML code
+        /// </summary>
+        VIR_FROM_XML = 5,
+        /// <summary>
+        /// Error when operating on a domain
+        /// </summary>
+        VIR_FROM_DOM = 6,
+        /// <summary>
+        /// Error in the XML-RPC code
+        /// </summary>
+        VIR_FROM_RPC = 7,
+        /// <summary>
+        /// Error in the proxy code
+        /// </summary>
+        VIR_FROM_PROXY = 8,
+        /// <summary>
+        /// Error in the configuration file handling
+        /// </summary>
+        VIR_FROM_CONF = 9,
+        /// <summary>
+        /// Error at the QEMU daemon
+        /// </summary>
+        VIR_FROM_QEMU = 10,
+        /// <summary>
+        /// Error when operating on a network
+        /// </summary>
+        VIR_FROM_NET = 11,
+        /// <summary>
+        /// Error from test driver
+        /// </summary>
+        VIR_FROM_TEST = 12,
+        /// <summary>
+        /// Error from remote driver
+        /// </summary>
+        VIR_FROM_REMOTE = 13,
+        /// <summary>
+        /// Error from OpenVZ driver
+        /// </summary>
+        VIR_FROM_OPENVZ = 14,
+        /// <summary>
+        /// Error at Xen XM layer
+        /// </summary>
+        VIR_FROM_XENXM = 15,
+        /// <summary>
+        /// Error in the Linux Stats code
+        /// </summary>
+        VIR_FROM_STATS_LINUX = 16,
+        /// <summary>
+        /// Error from Linux Container driver
+        /// </summary>
+        VIR_FROM_LXC = 17,
+        /// <summary>
+        /// Error from storage driver
+        /// </summary>
+        VIR_FROM_STORAGE = 18,
+        /// <summary>
+        /// Error from network config
+        /// </summary>
+        VIR_FROM_NETWORK = 19,
+        /// <summary>
+        /// Error from domain config
+        /// </summary>
+        VIR_FROM_DOMAIN = 20,
+        /// <summary>
+        /// Error at the UML driver
+        /// </summary>
+        VIR_FROM_UML = 21,
+        /// <summary>
+        /// Error from node device monitor
+        /// </summary>
+        VIR_FROM_NODEDEV = 22,
+        /// <summary>
+        /// Error from xen inotify layer
+        /// </summary>
+        VIR_FROM_XEN_INOTIFY = 23,
+        /// <summary>
+        /// Error from security framework
+        /// </summary>
+        VIR_FROM_SECURITY = 24,
+        /// <summary>
+        /// Error from VirtualBox driver
+        /// </summary>
+        VIR_FROM_VBOX = 25,
+        /// <summary>
+        /// Error when operating on an interface
+        /// </summary>
+        VIR_FROM_INTERFACE = 26,
+        /// <summary>
+        /// Error from OpenNebula driver
+        /// </summary>
+        VIR_FROM_ONE = 27,
+        /// <summary>
+        /// Error from ESX driver
+        /// </summary>
+        VIR_FROM_ESX = 28,
+        /// <summary>
+        /// Error from IBM power hypervisor
+        /// </summary>
+        VIR_FROM_PHYP = 29,
+        /// <summary>
+        /// Error from secret storage
+        /// </summary>
+        VIR_FROM_SECRET = 30,
+        /// <summary>
+        /// Error from CPU driver
+        /// </summary>
+        VIR_FROM_CPU = 31,
+        /// <summary>
+        /// Error from XenAPI
+        /// </summary>
+        VIR_FROM_XENAPI = 32,
+        /// <summary>
+        /// Error from network filter driver
+        /// </summary>
+        VIR_FROM_NWFILTER = 33,
+        /// <summary>
+        /// Error from Synchronous hooks
+        /// </summary>
+        VIR_FROM_HOOK = 34,
+        /// <summary>
+        /// Error from domain snapshot
+        /// </summary>
+        VIR_FROM_DOMAIN_SNAPSHOT = 35
+    }
+
+    /// <summary>
+    /// Enumerate the error levels
+    /// </summary>
+    public enum virErrorLevel
+    {
+        /// <summary>
+        /// No error
+        /// </summary>
+        VIR_ERR_NONE = 0,
+        /// <summary>
+        /// A simple warning.
+        /// </summary>
+        VIR_ERR_WARNING = 1,
+        /// <summary>
+        /// An error.
+        /// </summary>
+        VIR_ERR_ERROR = 2,
+    }
+    ///<summary>
     /// Type of handles for callback
     ///</summary>
     [Flags]
diff --git a/MarshalHelper.cs b/MarshalHelper.cs
new file mode 100644
index 0000000..61d486a
--- /dev/null
+++ b/MarshalHelper.cs
@@ -0,0 +1,36 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Runtime.InteropServices;
+using System.Text;
+
+namespace LibvirtBindings
+{
+    public class MarshalHelper
+    {
+        public static string[] ptrToStringArray(IntPtr stringPtr, int stringCount)
+        {
+            string[] members = new string[stringCount];
+            for (int i = 0; i < stringCount; ++i)
+            {
+                IntPtr s = Marshal.ReadIntPtr(stringPtr, i * IntPtr.Size);
+                members[i] = Marshal.PtrToStringAnsi(s);
+            }
+            return members;
+        }
+
+        public static string ptrToString(IntPtr stringPtr)
+        {
+            IntPtr s = Marshal.ReadIntPtr(stringPtr, IntPtr.Size);
+            return Marshal.PtrToStringAnsi(s);
+        }
+    }
+}
diff --git a/NativeFunctions.cs b/NativeFunctions.cs
new file mode 100644
index 0000000..fc71647
--- /dev/null
+++ b/NativeFunctions.cs
@@ -0,0 +1,23 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Runtime.InteropServices;
+using System.Text;
+
+namespace LibvirtBindings
+{
+    public class NativeFunctions
+    {
+        // TODO : this is atemporary workaround for virConnectOpenAuth callback, this should be removed
+        [DllImport("msvcrt.dll", EntryPoint = "_strdup", CallingConvention = CallingConvention.Cdecl)]
+        public static extern IntPtr StrDup(IntPtr strSource);
+    }
+}
diff --git a/StringWithoutNativeCleanUpMarshaler.cs b/StringWithoutNativeCleanUpMarshaler.cs
index 45cd447..28876fc 100644
--- a/StringWithoutNativeCleanUpMarshaler.cs
+++ b/StringWithoutNativeCleanUpMarshaler.cs
@@ -1,4 +1,12 @@
-﻿using System;
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+using System;
 using System.Runtime.InteropServices;
 
 namespace LibvirtBindings
diff --git a/examples/MonoDevelop/virConnectOpenAuth/MainWindow.cs b/examples/MonoDevelop/virConnectOpenAuth/MainWindow.cs
index fdbf318..c34c7db 100644
--- a/examples/MonoDevelop/virConnectOpenAuth/MainWindow.cs
+++ b/examples/MonoDevelop/virConnectOpenAuth/MainWindow.cs
@@ -47,14 +47,14 @@ public partial class MainWindow : Gtk.Window
         };
 		
 		// Request the connection
-        IntPtr conn = libVirt.virConnectOpenAuth(entry1.Text, ref auth, 0);
+        IntPtr conn = virConnect.OpenAuth(entry1.Text, ref auth, 0);
 		
 		if (conn != IntPtr.Zero)
         {
             // Get the number of defined (not running) domains
-            int numOfDefinedDomains = libVirt.virConnectNumOfDefinedDomains(conn);
+            int numOfDefinedDomains = virConnect.NumOfDefinedDomains(conn);
             string[] definedDomainNames = new string[numOfDefinedDomains];
-            if (libVirt.virConnectListDefinedDomains(conn, ref definedDomainNames, numOfDefinedDomains) == -1)
+            if (virConnect.ListDefinedDomains(conn, ref definedDomainNames, numOfDefinedDomains) == -1)
             {
 				ShowError("Unable to list defined domains");
                 return;
@@ -67,9 +67,9 @@ public partial class MainWindow : Gtk.Window
 			}
 			
             // Get the number of running domains
-            int numOfRunningDomain = libVirt.virConnectNumOfDomains(conn);
+            int numOfRunningDomain = virConnect.NumOfDomains(conn);
             int[] runningDomainIDs = new int[numOfRunningDomain];
-            if (libVirt.virConnectListDomains(conn, runningDomainIDs, numOfRunningDomain) == -1)
+            if (virConnect.ListDomains(conn, runningDomainIDs, numOfRunningDomain) == -1)
             {
                 ShowError("Unable to list running domains");
                 return;
@@ -78,13 +78,13 @@ public partial class MainWindow : Gtk.Window
             // Add the domain names to the listbox
             foreach (int runningDomainID in runningDomainIDs)
             {
-                IntPtr domainPtr = libVirt.virDomainLookupByID(conn, runningDomainID);
+                IntPtr domainPtr = virDomain.LookupByID(conn, runningDomainID);
                 if (domainPtr == IntPtr.Zero)
                 {
                     ShowError("Unable to lookup domains by id");
                     return;
                 }
-                string domainName = libVirt.virDomainGetName(domainPtr);
+                string domainName = virDomain.GetName(domainPtr);
                 if (string.IsNullOrEmpty(domainName))
                 {
                     ShowError("Unable to get domain name");
@@ -92,7 +92,7 @@ public partial class MainWindow : Gtk.Window
                 }
                 AddDomainInTreeView(domainName);
             }
-            libVirt.virConnectClose(conn);
+            virConnect.Close(conn);
         }
         else
         {
diff --git a/examples/VisualStudio/virConnectOpenAuth/Form1.cs b/examples/VisualStudio/virConnectOpenAuth/Form1.cs
index ce9a896..6ba9f5a 100644
--- a/examples/VisualStudio/virConnectOpenAuth/Form1.cs
+++ b/examples/VisualStudio/virConnectOpenAuth/Form1.cs
@@ -59,14 +59,14 @@ namespace virConnectOpenAuth
             };
 
             // Request the connection
-            IntPtr conn = libVirt.virConnectOpenAuth(tbURI.Text, ref auth, 0);
+            IntPtr conn = virConnect.OpenAuth(tbURI.Text, ref auth, 0);
 
             if (conn != IntPtr.Zero)
             {
                 // Get the number of defined (not running) domains
-                int numOfDefinedDomains = libVirt.virConnectNumOfDefinedDomains(conn);
+                int numOfDefinedDomains = virConnect.NumOfDefinedDomains(conn);
                 string[] definedDomainNames = new string[numOfDefinedDomains];
-                if (libVirt.virConnectListDefinedDomains(conn, ref definedDomainNames, numOfDefinedDomains) == -1)
+                if (virConnect.ListDefinedDomains(conn, ref definedDomainNames, numOfDefinedDomains) == -1)
                 {
                    MessageBox.Show("Unable to list defined domains", "List defined domains failed", MessageBoxButtons.OK,
                                     MessageBoxIcon.Error);
@@ -78,9 +78,9 @@ namespace virConnectOpenAuth
                     lbDomains.Items.Add(domainName);
 
                 // Get the number of running domains
-                int numOfRunningDomain = libVirt.virConnectNumOfDomains(conn);
+                int numOfRunningDomain = virConnect.NumOfDomains(conn);
                 int[] runningDomainIDs = new int[numOfRunningDomain];
-                if (libVirt.virConnectListDomains(conn, runningDomainIDs, numOfRunningDomain) == -1)
+                if (virConnect.ListDomains(conn, runningDomainIDs, numOfRunningDomain) == -1)
                 {
                     MessageBox.Show("Unable to list running domains", "List running domains failed", MessageBoxButtons.OK,
                                     MessageBoxIcon.Error);
@@ -90,14 +90,14 @@ namespace virConnectOpenAuth
                 // Add the domain names to the listbox
                 foreach (int runningDomainID in runningDomainIDs)
                 {
-                    IntPtr domainPtr = libVirt.virDomainLookupByID(conn, runningDomainID);
+                    IntPtr domainPtr = virDomain.LookupByID(conn, runningDomainID);
                     if (domainPtr == IntPtr.Zero)
                     {
                         MessageBox.Show("Unable to lookup domains by id", "Lookup domain failed", MessageBoxButtons.OK,
                                     MessageBoxIcon.Error);
                         return;
                     }
-                    string domainName = libVirt.virDomainGetName(domainPtr);
+                    string domainName = virDomain.GetName(domainPtr);
                     if (string.IsNullOrEmpty(domainName))
                     {
                         MessageBox.Show("Unable to get domain name", "Get domain name failed", MessageBoxButtons.OK,
@@ -106,7 +106,7 @@ namespace virConnectOpenAuth
                     }
                     lbDomains.Items.Add(domainName);
                 }
-                libVirt.virConnectClose(conn);
+                virConnect.Close(conn);
             }
             else
             {
diff --git a/projects/MonoDevelop/LibvirtBindings.csproj b/projects/MonoDevelop/LibvirtBindings.csproj
index 62d90e5..accacc8 100644
--- a/projects/MonoDevelop/LibvirtBindings.csproj
+++ b/projects/MonoDevelop/LibvirtBindings.csproj
@@ -34,9 +34,6 @@
   </ItemGroup>
   <ItemGroup>
     <Compile Include="AssemblyInfo.cs" />
-    <Compile Include="..\..\Libvirt.cs">
-      <Link>Libvirt.cs</Link>
-    </Compile>
     <Compile Include="..\..\LibvirtError.cs">
       <Link>LibvirtError.cs</Link>
     </Compile>
@@ -46,6 +43,50 @@
     <Compile Include="..\..\StringWithoutNativeCleanUpMarshaler.cs">
       <Link>StringWithoutNativeCleanUpMarshaler.cs</Link>
     </Compile>
+    <Compile Include="..\..\MarshalHelper.cs">
+      <Link>MarshalHelper.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virConnect.cs">
+      <Link>virConnect.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virDomain.cs">
+      <Link>virDomain.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virEvent.cs">
+      <Link>virEvent.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virInterface.cs">
+      <Link>virInterface.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virLibrary.cs">
+      <Link>virLibrary.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virNetwork.cs">
+      <Link>virNetwork.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virNode.cs">
+      <Link>virNode.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virSecret.cs">
+      <Link>virSecret.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virStoragePool.cs">
+      <Link>virStoragePool.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virStorageVol.cs">
+      <Link>virStorageVol.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virStream.cs">
+      <Link>virStream.cs</Link>
+    </Compile>
+    <Compile Include="..\..\NativeFunctions.cs">
+      <Link>NativeFunctions.cs</Link>
+    </Compile>
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
+  <ItemGroup>
+    <None Include="LibvirtBindings.dll.config">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
+  </ItemGroup>
 </Project>
\ No newline at end of file
diff --git a/projects/VisualStudio/LibvirtBindings.csproj b/projects/VisualStudio/LibvirtBindings.csproj
index 43990ba..bbb6ecd 100644
--- a/projects/VisualStudio/LibvirtBindings.csproj
+++ b/projects/VisualStudio/LibvirtBindings.csproj
@@ -21,6 +21,7 @@
     <DefineConstants>TRACE;DEBUG;WINDOWS</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <AllowUnsafeBlocks>false</AllowUnsafeBlocks>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
     <DebugType>pdbonly</DebugType>
@@ -40,18 +41,54 @@
     <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="..\..\Libvirt.cs">
-      <Link>Libvirt.cs</Link>
-    </Compile>
     <Compile Include="..\..\LibvirtError.cs">
       <Link>LibvirtError.cs</Link>
     </Compile>
     <Compile Include="..\..\LibvirtTypes.cs">
       <Link>LibvirtTypes.cs</Link>
     </Compile>
+    <Compile Include="..\..\MarshalHelper.cs">
+      <Link>MarshalHelper.cs</Link>
+    </Compile>
+    <Compile Include="..\..\NativeFunctions.cs">
+      <Link>NativeFunctions.cs</Link>
+    </Compile>
     <Compile Include="..\..\StringWithoutNativeCleanUpMarshaler.cs">
       <Link>StringWithoutNativeCleanUpMarshaler.cs</Link>
     </Compile>
+    <Compile Include="..\..\virConnect.cs">
+      <Link>virConnect.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virDomain.cs">
+      <Link>virDomain.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virEvent.cs">
+      <Link>virEvent.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virInterface.cs">
+      <Link>virInterface.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virLibrary.cs">
+      <Link>virLibrary.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virNetwork.cs">
+      <Link>virNetwork.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virNode.cs">
+      <Link>virNode.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virSecret.cs">
+      <Link>virSecret.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virStoragePool.cs">
+      <Link>virStoragePool.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virStorageVol.cs">
+      <Link>virStorageVol.cs</Link>
+    </Compile>
+    <Compile Include="..\..\virStream.cs">
+      <Link>virStream.cs</Link>
+    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
